*** Settings ***
Library    Process
Library    Commander
Library    OperatingSystem
Library    String
Library    Collections

*** Variables ***
@{COMMAND1}    echo    a b c
@{COMMAND2}    cut     -f2
@{COMMAND3}    wc

*** Test Cases ***
Test Execute Pipeline
    ${proc}    Execute Pipeline    ${COMMAND1}    ${COMMAND2}    ${COMMAND3}
    ${expected}    Catenate    SEPARATOR=${SPACE*7}    ${EMPTY}    1    3    6
    Should Be Equal As Strings    ${SPACE}${proc.stdout}    ${expected}

Test Execute Pipeline stdout
    ${proc}    Execute Pipeline    ${COMMAND1}    ${COMMAND2}    ${COMMAND3}
    ...    stdout=out
    ${expected}    Catenate    SEPARATOR=${SPACE*7}    ${EMPTY}    1    3    6
    ${expected}    Get Substring    ${expected}    1
    ${output}    Get File    out
    ${output}    Split To Lines    ${output}
    Should Be Equal As Strings    ${output}[0]    ${expected}

Test Execute Pipeline stdout append
    ${existing}    Get File    exist
    ${proc}    Execute Pipeline    ${COMMAND1}    ${COMMAND2}    ${COMMAND3}
    ...    stdout=exist    append=True
    ${expected}    Catenate    SEPARATOR=${SPACE*7}    ${EMPTY}    1    3    6
    ${expected}    Get Substring    ${expected}    1
    ${output}    Get File    exist
    ${output}    Split To Lines    ${output}
    Should Be Equal As Strings    ${output}[0]    ${existing}${expected}